////////////////////////////////////////////////////////////////////////////////////////////

var movement_speed = 0.9;
var rotation_speed = 0.15;
var engine_freq = 15; // controls the engine sound frequency for player's engine
var horn_handle;

////////////////////////////////////////////////////////////////////////////////////////////

function car_camera();
function horn();

////////////////////////////////////////////////////////////////////////////////////////////

sound plengine_wav = <plengine.wav>; // player's engine sound
sound plhorn_wav = <plhorn.wav>; // player's horn

////////////////////////////////////////////////////////////////////////////////////////////

bmap speedo_pcx = <speedo.pcx>;

////////////////////////////////////////////////////////////////////////////////////////////

panel speedo_pan // that's the speedometer panel
{
	bmap = speedo_pcx;
	pos_x = 640;
	pos_y = 450;
	layer = 10;
	flags = overlay, refresh, visible;
}

entity needle // needle entity, will appear in the center of speedo_pan
{
	type = <needle.tga>;
	layer = 20;
	scale_x = 0.15; // needle width
	scale_y = 0.25; // needle length
	x = 200; // position in front of the camera
	y = -91.5; // position on the screen (x axis)
	z = -65; // position on the screen (y axis)
	view  = camera;
	flags = overlay, nofilter, visible;
}

////////////////////////////////////////////////////////////////////////////////////////////

action players_car 
{
	var players_engine; // engine sound handle
	var player_dist;
	var player_speed;
	var minimum_z;
	player = my; // I'm the player
	my.albedo = 0;
	players_engine = ent_playloop (my, plengine_wav, 50); // play the engine sound in a loop
	while (1)
	{
		player_speed.x = movement_speed * (key_cuu - 0.4 * key_cud); // backwards movement speed = 40%
		my.skill1 = player_speed.x * time + max (1 - time * 0.02, 0) * my.skill1; // compute speed
		player_dist.x = my.skill1 * time; // time correct the speed
		player_dist.y = 0;

		// you should use vec_for_min instead of min_z if you plan to use an animtated (destroyable) model for player's car
		// the value returned by min_z and vec_for_min are identical if the model has a single animation frame
		// simply remove the comments from the two lines below if you want to use vec_for_min
//		vec_for_min(temp, my); // get the lowest vertex coordinate
//		my.min_z = temp.z; // set the new min_z value for player's car

		vec_set (temp, my.x);
		temp.z -= 1000;
		trace_mode = ignore_me + scan_texture;
		player_dist.z = -trace (my.x, temp) - my.min_z;

		if (str_cmpi (tex_name, "tilegrass"))
		{
			if (movement_speed > 0.1)
			{
				movement_speed -= 5 * time;
			}
			else
			{
				movement_speed = 0.1;
			}
		}
		else
		{
			if (movement_speed < 0.9)
			{
				movement_speed += 10 * time;
			}
			else
			{
				movement_speed = 0.9;
			}
		}
		
		// new code starts here

		temp.tilt = 0;
		temp.roll = 0;
		temp.pan = -my.pan;
		vec_rotate(normal, temp);
		temp.tilt = -asin(normal.x);
		temp.roll = -asin(normal.y);
		my.tilt += 0.1 * ang(temp.tilt - my.tilt); // play with 0.1
		my.roll += 0.1 * ang(temp.roll - my.roll); // play with 0.1

		// new code ends here
		
		move_mode = ignore_passable + glide;		
		my.skill2 = ent_move (player_dist, nullvector); // now ent_move the player
		if (my.skill2 > 0) // change gears automatically, depending on the value stored in skill2
		{
			engine_freq = 15;  
		} 
		if (my.skill2 > 8)
		{
			engine_freq = 20;
		}
		if (my.skill2 > 15)
		{
			engine_freq = 22;
		}
		if (my.skill2 > 19)
		{
			engine_freq = 23.5;
		}

		player_speed.pan = rotation_speed * (key_cul - key_cur) * my.skill2; // allow rotations only if the car is moving
		my.skill3 = time * player_speed.pan + max (1 - time * 0.7, 0) * my.skill3; // rotation speed
		my.pan += my.skill3 * time; // time corrected rotation
	
		my.skill4 = max (50, my.skill2 * engine_freq); // play an engine sound at the minimum speed too
		snd_tune (players_engine, 50, my.skill4, 0); // tune the engine sound

		if (key_cud == on)
		{
			my.skin = 2;
		}
		else
		{
			my.skin = 1;
		}

		car_camera(); // update the camera position
		wait(1);
	}
}

starter set_needle()
{
	var needle_angle;
	while (player == null) {wait (1);}
	while (1)
	{
		needle_angle = player.skill2 * 12.17 - 140;  // -140...+140 degrees = 0...140 mph
		needle.roll = max (-140, -needle_angle);  // the speedometer shouldn't display values below 0 mph (roll = -140 degrees)
		wait (1);
	}
}

/*function car_camera()
{	
	camera.x = player.x;
	camera.y = player.y + 300;
	camera.z = player.z + 20; // play with this value
	camera.pan = 270;
}*/

function horn()
{
	snd_play (plhorn_wav, 100, 0);
}

on_h = horn;
//--------------------------------------------------------------------------------------------------
var camera_number;
function car_camera()
{
  while (1)
  {
	camera.x = player.x;
	camera.y = player.y + 300;
	camera.z = player.z + 20; // play with this value
	camera.pan = 270;  
  
    if (key_1 == on) {camera_number = 1;}
    if (key_2 == on) {camera_number = 2;}
    if (key_3 == on) {camera_number = 3;}
    if (camera_number == 1) // top view
    {
       camera.x = player.x;
       camera.y = player.y;
       camera.z = player.z + 900; // play with this value
       camera.pan = player.pan;
       camera.tilt = -90;
    }
    if (camera_number == 2) // simulated first person view
    {
       camera.x = player.x - 20 * cos(player.pan);
       camera.y = player.y - 20 * sin(player.pan);
       camera.z = player.z + 18;
       camera.pan = player.pan;
       camera.tilt = 0;
    }
    if (camera_number == 3) // true isometric view
    {
       camera.x = player.x - 200 * cos(player.pan); // 200 = distance
       camera.y = player.y - 200 * sin(player.pan); // same value here
       camera.z = player.z + 150; // above the player
       camera.pan = player.pan;
       camera.tilt = -27; // look down at the player
    }
    wait (1);
  }
}        

